
using System;
using System.Linq;
using System.Collections.Generic;

using Mono.Unix;

using Hyena;
using Hyena.Gui;

using PdfMod;

namespace PdfMod.Actions
{
    public class MoveAction : BasePageAction
    {
        private int [] old_indices;
        private int to_index;

        public MoveAction (Document document, IEnumerable<Page> pages, int to_index) : base (document, pages)
        {
            this.to_index = to_index;
        }

        public override void Undo ()
        {
            if (old_indices == null) {
                throw new InvalidOperationException (Catalog.GetString ("Error trying to unmove pages"));
            }

            Document.Move (to_index, Pages.ToArray (), old_indices);
            old_indices = null;
        }

        public override void Redo ()
        {
            if (old_indices != null) {
                throw new InvalidOperationException (Catalog.GetString ("Error trying to move pages"));
            }

            old_indices = Pages.Select<Page, int> (Document.IndexOf).ToArray ();
            Document.Move (to_index, Pages.ToArray (), null);
        }
    }
}
